package net.minecraft.src;
// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) braces deadcode 

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.lang.reflect.Field;
import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;
import java.util.logging.FileHandler;
import java.util.logging.Level;
import java.util.logging.Logger;
import java.util.logging.SimpleFormatter;
import java.util.zip.ZipEntry;
import java.util.zip.ZipInputStream;

import net.minecraft.server.MinecraftServer;

public final class ModLoader
{

    public static Logger getLogger()
    {
        return logger;
    }

    public static int AddAllFuel(int i)
    {
        logger.finest((new StringBuilder("Finding fuel for ")).append(i).toString());
        int j = 0;
        for(int k = 0; k < modList.size() && j == 0; k++)
        {
            j = ((BaseMod)modList.get(k)).AddFuel(i);
        }

        if(j != 0)
        {
            logger.finest((new StringBuilder("Returned ")).append(j).toString());
        }
        return j;
    }

    public static void AddAllRecipes(CraftingManager craftingmanager)
    {
        logger.finer("Initializing recipes");
        for(int i = 0; i < modList.size(); i++)
        {
            ((BaseMod)modList.get(i)).AddRecipes(craftingmanager);
        }

    }

    public static void AddSmelting(int i, ItemStack itemstack)
    {
        FurnaceRecipes.func_21162_a().func_21160_a(i, itemstack);
    }

    private static void addMod(ClassLoader classloader, String s)
    {
        try
        {
            String s1 = s.substring(0, s.length() - 6);
            Class class1 = classloader.loadClass(s1);
            if(class1.getSuperclass() != (BaseMod.class))
            {
                return;
            }
            BaseMod basemod = (BaseMod)class1.newInstance();
            if(basemod != null)
            {
                modList.add(basemod);
                logger.fine((new StringBuilder("Mod Loaded: \"")).append(basemod.toString()).append("\" from ").append(s).toString());
                System.out.println((new StringBuilder("Mod Loaded: ")).append(basemod.toString()).toString());
            }
        }
        catch(Exception exception)
        {
            logger.throwing("ModLoader", "addMod", exception);
            exception.printStackTrace();
        }
    }

    public static void addOverride(String s, String s1, int i)
    {
        logger.finer((new StringBuilder("addOverride(")).append(s).append(",").append(s1).append(",").append(i).append(")").toString());
        Object obj = (List)overrides.get(s);
        if(obj == null)
        {
            obj = new LinkedList();
            overrides.put(s, obj);
        }
        ((List) (obj)).add(new java.util.AbstractMap.SimpleEntry(s1, Integer.valueOf(i)));
    }

    public static List getLoadedMods()
    {
        return Collections.unmodifiableList(modList);
    }
    
    public static MinecraftServer getMinecraftServerInstance()
    {
    	return instance;
    }

    public static Object getPrivateValue(Class class1, Object obj, int i)
        throws IllegalArgumentException, SecurityException, NoSuchFieldException
    {
        try
        {
            Field field = class1.getDeclaredFields()[i];
            field.setAccessible(true);
            return field.get(obj);
        }
        catch(IllegalAccessException illegalaccessexception)
        {
            logger.throwing("ModLoader", "getPrivateValue", illegalaccessexception);
            ThrowException("An impossible error has occured!", illegalaccessexception);
            return null;
        }
    }

    public static Object getPrivateValue(Class class1, Object obj, String s)
        throws IllegalArgumentException, SecurityException, NoSuchFieldException
    {
        try
        {
            Field field = class1.getDeclaredField(s);
            field.setAccessible(true);
            return field.get(obj);
        }
        catch(IllegalAccessException illegalaccessexception)
        {
            logger.throwing("ModLoader", "getPrivateValue", illegalaccessexception);
            ThrowException("An impossible error has occured!", illegalaccessexception);
            return null;
        }
    }

    public static int getUniqueEntityId()
    {
        return highestEntityId++;
    }

    private static int getUniqueItemSpriteIndex()
    {
        for(; itemSpriteIndex < usedItemSprites.length; itemSpriteIndex++)
        {
            if(!usedItemSprites[itemSpriteIndex])
            {
                usedItemSprites[itemSpriteIndex] = true;
                return itemSpriteIndex++;
            }
        }

        ThrowException(new Exception("No more empty item sprite indices left!"));
        return 0;
    }

    public static int getUniqueSpriteIndex(String s)
    {
        if(s.equals("/gui/items.png"))
        {
            return getUniqueItemSpriteIndex();
        }
        if(s.equals("/terrain.png"))
        {
            return getUniqueTerrainSpriteIndex();
        } else
        {
            ThrowException(new Exception((new StringBuilder("No registry for this texture: ")).append(s).toString()));
            return 0;
        }
    }

    private static int getUniqueTerrainSpriteIndex()
    {
        for(; terrainSpriteIndex < usedTerrainSprites.length; terrainSpriteIndex++)
        {
            if(!usedTerrainSprites[terrainSpriteIndex])
            {
                usedTerrainSprites[terrainSpriteIndex] = true;
                return terrainSpriteIndex++;
            }
        }

        ThrowException(new Exception("No more empty terrain sprite indices left!"));
        return 0;
    }

    private static void init()
    {
        String s = "1111111111111111111111111111111111111101111110011111111111110001111111111111111111111001111001111111100110000111111110000000011111111001100001110000000100000111000000010000011100000000000001110000000000000111000000000000000000000000000000001100000000000000";
        String s1 = "1111111111111111111111111111110111111100011111111111110001111110111111111111000011111111111111111111111111000000111111111111100011101100000010001110000000000000111000000000000011100000000000001110000000000111111000000000001101000000000001111111111111000011";
        for(int i = 0; i < 256; i++)
        {
            usedItemSprites[i] = s.charAt(i) == '1';
            usedTerrainSprites[i] = s1.charAt(i) == '1';
        }

        try
        {
            field_modifiers = (java.lang.reflect.Field.class).getDeclaredField("modifiers");
            field_modifiers.setAccessible(true);
            try
            {
                method_RegisterTileEntity = (TileEntity.class).getDeclaredMethod("a", new Class[] {
                    java.lang.Class.class, java.lang.String.class
                });
            }
            catch(NoSuchMethodException nosuchmethodexception)
            {
                method_RegisterTileEntity = (TileEntity.class).getDeclaredMethod("addMapping", new Class[] {
                    java.lang.Class.class, java.lang.String.class
                });
            }
            method_RegisterTileEntity.setAccessible(true);
            try
            {
                method_RegisterEntityID = (EntityList.class).getDeclaredMethod("a", new Class[] {
                    java.lang.Class.class, java.lang.String.class, Integer.TYPE
                });
            }
            catch(NoSuchMethodException nosuchmethodexception1)
            {
                method_RegisterEntityID = (EntityList.class).getDeclaredMethod("func_563_a", new Class[] {
                    java.lang.Class.class, java.lang.String.class, Integer.TYPE
                });
            }
            method_RegisterEntityID.setAccessible(true);
            
            // TODO
            try
            {
                method_AddIdClassMapping = (Packet.class).getDeclaredMethod("a", new Class[] {
                		int.class, Class.class
                });
            }
            catch(NoSuchMethodException nosuchmethodexception1)
            {
            	method_AddIdClassMapping = (Packet.class).getDeclaredMethod("addIdClassMapping", new Class[] {
            			int.class, Class.class
                });
            }
            method_AddIdClassMapping.setAccessible(true);
            
            addCustomPacketMapping();
        }
        catch(SecurityException securityexception)
        {
            logger.throwing("ModLoader", "init", securityexception);
            ThrowException(securityexception);
        }
        catch(NoSuchFieldException nosuchfieldexception)
        {
            logger.throwing("ModLoader", "init", nosuchfieldexception);
            ThrowException(nosuchfieldexception);
        }
        catch(NoSuchMethodException nosuchmethodexception2)
        {
            logger.throwing("ModLoader", "init", nosuchmethodexception2);
            ThrowException(nosuchmethodexception2);
        }
        File file = instance.getFile("ModLoader.txt");
        try
        {
            logger.setLevel(Level.FINER);
            FileHandler filehandler = new FileHandler(file.getPath());
            filehandler.setFormatter(new SimpleFormatter());
            logger.addHandler(filehandler);
            File file1 = new File((ModLoader.class).getProtectionDomain().getCodeSource().getLocation().toURI());
            readFromClassPath(file1);
        }
        catch(Exception exception)
        {
            logger.throwing("ModLoader", "init", exception);
            ThrowException("ModLoader has failed to initialize.", exception);
        }
        hasInit = true;
        for(int j = 0; j < modList.size(); j++)
        {
            ((BaseMod)modList.get(j)).ModsLoaded();
        }

    }

    public static boolean isModLoaded(String s)
    {
        if(!hasInit)
        {
            init();
        }
        Class class1 = null;
        try
        {
            class1 = Class.forName(s);
        }
        catch(ClassNotFoundException classnotfoundexception)
        {
            return false;
        }
        if(class1 != null)
        {
            for(int i = 0; i < modList.size(); i++)
            {
                if(class1.isInstance(modList.get(i)))
                {
                    return true;
                }
            }

        }
        return false;
    }

    public static void PopulateChunk(IChunkProvider ichunkprovider, int i, int j, World world)
    {
        if(!hasInit)
        {
            init();
        }
        for(int k = 0; k < modList.size(); k++)
        {
            if(ichunkprovider instanceof ChunkProviderGenerate)
            {
                ((BaseMod)modList.get(k)).GenerateSurface(world, world.rand, i, j);
            } else
            if(ichunkprovider instanceof ChunkProviderHell)
            {
                ((BaseMod)modList.get(k)).GenerateNether(world, world.rand, i, j);
            }
        }

    }
    
    private static void readFromClassPath(File file)
        throws FileNotFoundException, IOException
    {
        logger.finer((new StringBuilder("Adding mods from ")).append(file.getCanonicalPath()).toString());
        ClassLoader classloader = (ModLoader.class).getClassLoader();
        if(file.isFile() && (file.getName().endsWith(".jar") || file.getName().endsWith(".zip")))
        {
            logger.finer("Zip found.");
            ZipInputStream zipinputstream = new ZipInputStream(new FileInputStream(file));
            Object obj = null;
            do
            {
                ZipEntry zipentry = zipinputstream.getNextEntry();
                if(zipentry == null)
                {
                    break;
                }
                String s = zipentry.getName();
                if(!zipentry.isDirectory() && s.startsWith("mod_") && s.endsWith(".class"))
                {
                    addMod(classloader, s);
                }
            } while(true);
        } else
        if(file.isDirectory())
        {
        	logger.finer("Directory found.");
            addModDirectory(file, classloader);
        }
    }
    
    // TODO
	private static List<String> addedMods = new ArrayList<String>();
	private static void addModDirectory(File file, ClassLoader classloader)
	{
		File afile[] = file.listFiles();
		if(afile != null)
		{
		    for(int i = 0; i < afile.length; i++)
		    {
		    	if(afile[i].isDirectory())
		    	{
		    		addModDirectory(afile[i], classloader);
		    	}
		    	else
		    	{
		    		String s1 = afile[i].getName();
			        if(afile[i].isFile() && s1.startsWith("mod_") && s1.endsWith(".class") && !addedMods.contains(s1))
			        {
			        	addedMods.add(s1);
			            addMod(classloader, "net.minecraft.src." + s1);
			        }
		    	}
		    }
		}
	}

    public static void RegisterBlock(Block block)
    {
        RegisterBlock(block, null);
    }

    public static void RegisterBlock(Block block, Class class1)
    {
        try
        {
            int i = block.blockID;
            ItemBlock itemblock = null;
            if(class1 != null)
            {
                itemblock = (ItemBlock)class1.getConstructor(new Class[] {
                    Integer.TYPE
                }).newInstance(new Object[] {
                    Integer.valueOf(i - 256)
                });
            } else
            {
                itemblock = new ItemBlock(i - 256);
            }
            if(Block.blocksList[i] != null && Item.itemsList[i] == null)
            {
                Item.itemsList[i] = itemblock;
            }
        }
        catch(IllegalArgumentException illegalargumentexception)
        {
            logger.throwing("ModLoader", "RegisterBlock", illegalargumentexception);
            ThrowException(illegalargumentexception);
        }
        catch(IllegalAccessException illegalaccessexception)
        {
            logger.throwing("ModLoader", "RegisterBlock", illegalaccessexception);
            ThrowException(illegalaccessexception);
        }
        catch(SecurityException securityexception)
        {
            logger.throwing("ModLoader", "RegisterBlock", securityexception);
            ThrowException(securityexception);
        }
        catch(InstantiationException instantiationexception)
        {
            logger.throwing("ModLoader", "RegisterBlock", instantiationexception);
            ThrowException(instantiationexception);
        }
        catch(InvocationTargetException invocationtargetexception)
        {
            logger.throwing("ModLoader", "RegisterBlock", invocationtargetexception);
            ThrowException(invocationtargetexception);
        }
        catch(NoSuchMethodException nosuchmethodexception)
        {
            logger.throwing("ModLoader", "RegisterBlock", nosuchmethodexception);
            ThrowException(nosuchmethodexception);
        }
    }

    public static void RegisterEntityID(Class class1, String s, int i)
    {
        try
        {
            method_RegisterEntityID.invoke(null, new Object[] {
                class1, s, Integer.valueOf(i)
            });
        }
        catch(IllegalArgumentException illegalargumentexception)
        {
            logger.throwing("ModLoader", "RegisterEntityID", illegalargumentexception);
            ThrowException(illegalargumentexception);
        }
        catch(IllegalAccessException illegalaccessexception)
        {
            logger.throwing("ModLoader", "RegisterEntityID", illegalaccessexception);
            ThrowException(illegalaccessexception);
        }
        catch(InvocationTargetException invocationtargetexception)
        {
            logger.throwing("ModLoader", "RegisterEntityID", invocationtargetexception);
            ThrowException(invocationtargetexception);
        }
    }

    public static void RegisterTileEntity(Class class1, String s)
    {
        try
        {
            method_RegisterTileEntity.invoke(null, new Object[] {
                class1, s
            });
        }
        catch(IllegalArgumentException illegalargumentexception)
        {
            logger.throwing("ModLoader", "RegisterTileEntity", illegalargumentexception);
            ThrowException(illegalargumentexception);
        }
        catch(IllegalAccessException illegalaccessexception)
        {
            logger.throwing("ModLoader", "RegisterTileEntity", illegalaccessexception);
            ThrowException(illegalaccessexception);
        }
        catch(InvocationTargetException invocationtargetexception)
        {
            logger.throwing("ModLoader", "RegisterTileEntity", invocationtargetexception);
            ThrowException(invocationtargetexception);
        }
    }

    public static void setPrivateValue(Class class1, Object obj, int i, Object obj1)
        throws IllegalArgumentException, SecurityException, NoSuchFieldException
    {
        try
        {
            Field field = class1.getDeclaredFields()[i];
            field.setAccessible(true);
            int j = field_modifiers.getInt(field);
            if((j & 0x10) != 0)
            {
                field_modifiers.setInt(field, j & 0xffffffef);
            }
            field.set(obj, obj1);
        }
        catch(IllegalAccessException illegalaccessexception)
        {
            logger.throwing("ModLoader", "setPrivateValue", illegalaccessexception);
            ThrowException("An impossible error has occured!", illegalaccessexception);
        }
    }

    public static void setPrivateValue(Class class1, Object obj, String s, Object obj1)
        throws IllegalArgumentException, SecurityException, NoSuchFieldException
    {
        try
        {
            Field field = class1.getDeclaredField(s);
            int i = field_modifiers.getInt(field);
            if((i & 0x10) != 0)
            {
                field_modifiers.setInt(field, i & 0xffffffef);
            }
            field.setAccessible(true);
            field.set(obj, obj1);
        }
        catch(IllegalAccessException illegalaccessexception)
        {
            logger.throwing("ModLoader", "setPrivateValue", illegalaccessexception);
            ThrowException("An impossible error has occured!", illegalaccessexception);
        }
    }

    public static void ThrowException(String s, Throwable throwable)
    {
        throw new RuntimeException(throwable);
    }

    private static void ThrowException(Throwable throwable)
    {
        ThrowException("Exception occured in ModLoader", throwable);
    }

    private ModLoader()
    {
    }

    private static Field field_modifiers = null;
    private static boolean hasInit = false;
    private static int highestEntityId = 3000;
    private static MinecraftServer instance = null;
    private static int itemSpriteIndex = 0;
    private static final Logger logger = Logger.getLogger("ModLoader");
    private static Method method_RegisterEntityID = null;
    private static Method method_RegisterTileEntity = null;
    private static final List modList = new ArrayList();
    private static final Map overrides = new HashMap();
    private static int terrainSpriteIndex = 0;
    private static final boolean usedItemSprites[] = new boolean[256];
    private static final boolean usedTerrainSprites[] = new boolean[256];

    // SDK
    public static void initServer(MinecraftServer minecraftServer)
    {
    	instance = minecraftServer;
    	init();
    }
    
    public static void AddAllEntityTrackers()
    {
    	entityTrackerMap = new HashMap<Class, SdkPair<Integer, Integer>>();
    	for(int i = 0; i < modList.size(); i++)
        {
            ((BaseMod)modList.get(i)).AddEntityTrackers(entityTrackerMap);
        }
    }

	public static void HandleEntityTrackers(EntityTracker entityTracker, Entity entity)
	{
		if(entityTrackerMap == null)
		{
			AddAllEntityTrackers();
		}
		
		Iterator<Map.Entry<Class, SdkPair<Integer, Integer>>> it = entityTrackerMap.entrySet().iterator();
    	while (it.hasNext())
    	{
    	    Map.Entry<Class, SdkPair<Integer, Integer>> entry = it.next();
    	    
    	    if(entry.getKey().isInstance(entity))
    	    {
    	    	entityTracker.func_6186_a(entity, entry.getValue().getLeft(), entry.getValue().getRight(), true);
    	    	return;
    	    }
    	}
	}
    
    public static void AddAllEntityTrackerEntries()
    {
    	entityTrackerEntryMap = new HashMap<Class, Integer>();
    	for(int i = 0; i < modList.size(); i++)
        {
            ((BaseMod)modList.get(i)).AddEntityTrackerEntries(entityTrackerEntryMap);
        }
    }

	public static int HandleEntityTrackerEntries(Entity entity)
	{
		if(entityTrackerEntryMap == null)
		{
			AddAllEntityTrackerEntries();
		}
        
		if(entityTrackerEntryMap.containsKey(entity.getClass()))
		{
			return entityTrackerEntryMap.get(entity.getClass());
		}
		else
		{
			return -1;
		}
	}

	public static void TickAll(MinecraftServer minecraftServer)
	{
		for(int i = 0; i < modList.size(); i++)
        {
            ((BaseMod)modList.get(i)).Tick(minecraftServer);
        }
	}
	
	public static void SendPacketToAll(BaseMod baseMod, Packet200ModLoader packet200ModLoader)
	{
		if(baseMod == null)
		{
			throw new IllegalArgumentException("baseMod cannot be null.");
		}
		
		packet200ModLoader.modId = baseMod.getId();
		SendPacketToAll(packet200ModLoader);
	}

	private static void SendPacketToAll(Packet200ModLoader packet200ModLoader)
	{
		for(int i = 0; i < instance.worldMngr.playerEntities.size(); i++)
        {
			((EntityPlayerMP)instance.worldMngr.playerEntities.get(i)).field_20908_a.sendPacket(packet200ModLoader);
        }
	}
	
	public static void SendPacketTo(BaseMod baseMod, EntityPlayerMP entityPlayer, Packet200ModLoader packet200ModLoader)
	{
		if(baseMod == null)
		{
			throw new IllegalArgumentException("baseMod cannot be null.");
		}
		
		packet200ModLoader.modId = baseMod.getId();
		SendPacketTo(entityPlayer, packet200ModLoader);
	}
	
	private static void SendPacketTo(EntityPlayerMP entityPlayer, Packet200ModLoader packet200ModLoader)
	{
		entityPlayer.field_20908_a.sendPacket(packet200ModLoader);
	}

	public static void HandleAllPackets(Packet200ModLoader packet200ModLoader, EntityPlayerMP entityPlayerMp)
	{
		if(packet200ModLoader.modId == "ModLoader".hashCode())
		{
			handleModCheckResponse(packet200ModLoader, entityPlayerMp);
		}
		else
		{
			for(int m = 0; m < modList.size(); m++)
	        {
	            if (((BaseMod)modList.get(m)).getId() == packet200ModLoader.modId)
	            {
	            	((BaseMod)modList.get(m)).HandlePacket(packet200ModLoader, entityPlayerMp);
	            	break;
	            }
	        }
		}
	}

	private static void handleModCheckResponse(Packet200ModLoader packet200ModLoader, EntityPlayerMP entityPlayerMp)
	{
		if(packet200ModLoader.dataString.length != 0)
		{
			StringBuilder modsMissing = new StringBuilder();
			for(int i = 0; i < packet200ModLoader.dataString.length; i++)
			{
				if(i != 0)
				{
					modsMissing.append(", ");
				}
				
				modsMissing.append(packet200ModLoader.dataString[i]);
			}
			
			entityPlayerMp.field_20908_a.func_43_c("You are missing the following mods: " + modsMissing.toString());
		}
	}
	
	public static void HandleAllLogins(EntityPlayerMP entityPlayerMp)
	{
		sendModCheck(entityPlayerMp);
		for(int m = 0; m < modList.size(); m++)
        {
            ((BaseMod)modList.get(m)).HandleLogin(entityPlayerMp);
        }
	}

	private static void sendModCheck(EntityPlayerMP entityPlayerMp)
	{
		// Send mod check packet
		Packet200ModLoader packetModCheck = new Packet200ModLoader();
		packetModCheck.modId = "ModLoader".hashCode();
		
		String[] modStrings = new String[modList.size()];
		for(int m = 0; m < modList.size(); m++)
        {
            modStrings[m] = ((BaseMod)modList.get(m)).toString();
        }
		
		SendPacketTo(entityPlayerMp, packetModCheck);
	}
	
	private static void addCustomPacketMapping()
	{
		try
		{
			method_AddIdClassMapping.invoke(null, 200, Packet200ModLoader.class);
		}
		catch (InvocationTargetException invocationtargetexception)
		{
			logger.throwing("ModLoader", "AddCustomPacketMapping", invocationtargetexception);
            ThrowException(invocationtargetexception);
		}
		catch (IllegalAccessException illegalaccessexception)
		{
			logger.throwing("ModLoader", "AddCustomPacketMapping", illegalaccessexception);
            ThrowException(illegalaccessexception);
		}
	}

	private static Map<Class, SdkPair<Integer, Integer>> entityTrackerMap = null;
	private static Map<Class, Integer> entityTrackerEntryMap = null;
	private static Method method_AddIdClassMapping = null;
}
